// _gen/core/value.asdl.cc is generated by asdl_main.py

#include "_gen/core/value.asdl.h"
#include <assert.h>
#include "prebuilt/asdl/runtime.mycpp.h"  // generated code uses wrappers here
#include "_gen/frontend/syntax.asdl.h"  // "use" in ASDL 
#include "_gen/core/runtime.asdl.h"  // "use" in ASDL 

// Generated code uses these types
using hnode_asdl::hnode;
using hnode_asdl::Field;
using hnode_asdl::color_e;


namespace value_asdl {


hnode_t* IntBox::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(StrFromC("IntBox"));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = Alloc<hnode::Leaf>(str(this->i), color_e::OtherConst);
  L->append(Alloc<Field>(StrFromC("i"), x0));

  return out_node;
}


hnode_t* ProcDefaults::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(StrFromC("ProcDefaults"));
  List<Field*>* L = out_node->fields;

  if (this->for_word != nullptr) {  // List
    hnode::Array* x0 = Alloc<hnode::Array>(Alloc<List<hnode_t*>>());
    for (ListIter<value_t*> it(this->for_word); !it.Done(); it.Next()) {
      value_t* i0 = it.Value();
      x0->children->append(i0->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC("for_word"), x0));
  }

  if (this->for_typed != nullptr) {  // List
    hnode::Array* x1 = Alloc<hnode::Array>(Alloc<List<hnode_t*>>());
    for (ListIter<value_t*> it(this->for_typed); !it.Done(); it.Next()) {
      value_t* i1 = it.Value();
      x1->children->append(i1->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC("for_typed"), x1));
  }

  if (this->for_named) {  // Dict
    auto m = Alloc<hnode::Leaf>(StrFromC("Dict"), color_e::OtherConst);
    hnode::Array* x2 = Alloc<hnode::Array>(NewList<hnode_t*>({m}));
    for (DictIter<BigStr*, value_t*> it(this->for_named); !it.Done();
         it.Next()) {
      auto k2 = it.Key();
      auto v2 = it.Value();
      x2->children->append(runtime::NewLeaf(k2, color_e::StringConst));
      x2->children->append(v2->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC ("for_named"), x2));
  }

  return out_node;
}


hnode_t* LeftName::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(StrFromC("LeftName"));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = runtime::NewLeaf(this->name, color_e::StringConst);
  L->append(Alloc<Field>(StrFromC("name"), x0));

  hnode_t* x1 = this->blame_loc->PrettyTree();
  L->append(Alloc<Field>(StrFromC("blame_loc"), x1));

  return out_node;
}

BigStr* y_lvalue_str(int tag, bool dot) {
  char buf[32];
  const char* v = nullptr;
  switch (tag) {
  case y_lvalue_e::Local:
    v = "Local"; break;
  case y_lvalue_e::Container:
    v = "Container"; break;
  default:
    assert(0);
  }
  if (dot) {
    snprintf(buf, 32, "y_lvalue.%s", v);
    return StrFromC(buf);
  } else {
    return StrFromC(v);
  }
}

hnode_t* y_lvalue__Container::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(y_lvalue_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = this->obj->PrettyTree();
  L->append(Alloc<Field>(StrFromC("obj"), x0));

  hnode_t* x1 = this->index->PrettyTree();
  L->append(Alloc<Field>(StrFromC("index"), x1));

  return out_node;
}


hnode_t* y_lvalue_t::PrettyTree() {
  switch (this->tag()) {
  case y_lvalue_e::Local: {
    LeftName* obj = static_cast<LeftName*>(this);
    return obj->PrettyTree();
  }
  case y_lvalue_e::Container: {
    y_lvalue__Container* obj = static_cast<y_lvalue__Container*>(this);
    return obj->PrettyTree();
  }
  default:
    assert(0);
  }
}
BigStr* sh_lvalue_str(int tag, bool dot) {
  char buf[32];
  const char* v = nullptr;
  switch (tag) {
  case sh_lvalue_e::Var:
    v = "Var"; break;
  case sh_lvalue_e::Indexed:
    v = "Indexed"; break;
  case sh_lvalue_e::Keyed:
    v = "Keyed"; break;
  default:
    assert(0);
  }
  if (dot) {
    snprintf(buf, 32, "sh_lvalue.%s", v);
    return StrFromC(buf);
  } else {
    return StrFromC(v);
  }
}

hnode_t* sh_lvalue__Indexed::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(sh_lvalue_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = runtime::NewLeaf(this->name, color_e::StringConst);
  L->append(Alloc<Field>(StrFromC("name"), x0));

  hnode_t* x1 = Alloc<hnode::Leaf>(str(this->index), color_e::OtherConst);
  L->append(Alloc<Field>(StrFromC("index"), x1));

  hnode_t* x2 = this->blame_loc->PrettyTree();
  L->append(Alloc<Field>(StrFromC("blame_loc"), x2));

  return out_node;
}


hnode_t* sh_lvalue__Keyed::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(sh_lvalue_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = runtime::NewLeaf(this->name, color_e::StringConst);
  L->append(Alloc<Field>(StrFromC("name"), x0));

  hnode_t* x1 = runtime::NewLeaf(this->key, color_e::StringConst);
  L->append(Alloc<Field>(StrFromC("key"), x1));

  hnode_t* x2 = this->blame_loc->PrettyTree();
  L->append(Alloc<Field>(StrFromC("blame_loc"), x2));

  return out_node;
}


hnode_t* sh_lvalue_t::PrettyTree() {
  switch (this->tag()) {
  case sh_lvalue_e::Var: {
    LeftName* obj = static_cast<LeftName*>(this);
    return obj->PrettyTree();
  }
  case sh_lvalue_e::Indexed: {
    sh_lvalue__Indexed* obj = static_cast<sh_lvalue__Indexed*>(this);
    return obj->PrettyTree();
  }
  case sh_lvalue_e::Keyed: {
    sh_lvalue__Keyed* obj = static_cast<sh_lvalue__Keyed*>(this);
    return obj->PrettyTree();
  }
  default:
    assert(0);
  }
}
BigStr* value_str(int tag, bool dot) {
  char buf[32];
  const char* v = nullptr;
  switch (tag) {
  case value_e::Undef:
    v = "Undef"; break;
  case value_e::Str:
    v = "Str"; break;
  case value_e::BashArray:
    v = "BashArray"; break;
  case value_e::BashAssoc:
    v = "BashAssoc"; break;
  case value_e::Null:
    v = "Null"; break;
  case value_e::Bool:
    v = "Bool"; break;
  case value_e::Int:
    v = "Int"; break;
  case value_e::Float:
    v = "Float"; break;
  case value_e::List:
    v = "List"; break;
  case value_e::Dict:
    v = "Dict"; break;
  case value_e::Eggex:
    v = "Eggex"; break;
  case value_e::Expr:
    v = "Expr"; break;
  case value_e::Template:
    v = "Template"; break;
  case value_e::Command:
    v = "Command"; break;
  case value_e::Block:
    v = "Block"; break;
  case value_e::Place:
    v = "Place"; break;
  case value_e::Module:
    v = "Module"; break;
  case value_e::IO:
    v = "IO"; break;
  case value_e::BuiltinFunc:
    v = "BuiltinFunc"; break;
  case value_e::BoundFunc:
    v = "BoundFunc"; break;
  case value_e::Proc:
    v = "Proc"; break;
  case value_e::Func:
    v = "Func"; break;
  case value_e::Slice:
    v = "Slice"; break;
  case value_e::Range:
    v = "Range"; break;
  default:
    assert(0);
  }
  if (dot) {
    snprintf(buf, 32, "value.%s", v);
    return StrFromC(buf);
  } else {
    return StrFromC(v);
  }
}

value__Undef* value::Undef = &gvalue__Undef.obj;

GcGlobal<value__Undef> gvalue__Undef = 
  { ObjHeader::Global(value_e::Undef) };

value__Null* value::Null = &gvalue__Null.obj;

GcGlobal<value__Null> gvalue__Null = 
  { ObjHeader::Global(value_e::Null) };

hnode_t* value__Undef::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  return out_node;
}


hnode_t* value__Str::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = runtime::NewLeaf(this->s, color_e::StringConst);
  L->append(Alloc<Field>(StrFromC("s"), x0));

  return out_node;
}


hnode_t* value__BashArray::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  if (this->strs != nullptr) {  // List
    hnode::Array* x0 = Alloc<hnode::Array>(Alloc<List<hnode_t*>>());
    for (ListIter<BigStr*> it(this->strs); !it.Done(); it.Next()) {
      BigStr* i0 = it.Value();
      x0->children->append(runtime::NewLeaf(i0, color_e::StringConst));
    }
    L->append(Alloc<Field>(StrFromC("strs"), x0));
  }

  return out_node;
}


hnode_t* value__BashAssoc::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  if (this->d) {  // Dict
    auto m = Alloc<hnode::Leaf>(StrFromC("Dict"), color_e::OtherConst);
    hnode::Array* x0 = Alloc<hnode::Array>(NewList<hnode_t*>({m}));
    for (DictIter<BigStr*, BigStr*> it(this->d); !it.Done(); it.Next()) {
      auto k0 = it.Key();
      auto v0 = it.Value();
      x0->children->append(runtime::NewLeaf(k0, color_e::StringConst));
      x0->children->append(runtime::NewLeaf(v0, color_e::StringConst));
    }
    L->append(Alloc<Field>(StrFromC ("d"), x0));
  }

  return out_node;
}


hnode_t* value__Null::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  return out_node;
}


hnode_t* value__Bool::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = Alloc<hnode::Leaf>(this->b ? runtime::TRUE_STR :
                                   runtime::FALSE_STR, color_e::OtherConst);
  L->append(Alloc<Field>(StrFromC("b"), x0));

  return out_node;
}


hnode_t* value__Int::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = Alloc<hnode::Leaf>(str(this->i), color_e::OtherConst);
  L->append(Alloc<Field>(StrFromC("i"), x0));

  return out_node;
}


hnode_t* value__Float::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = Alloc<hnode::Leaf>(str(this->f), color_e::OtherConst);
  L->append(Alloc<Field>(StrFromC("f"), x0));

  return out_node;
}


hnode_t* value__List::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  if (this->items != nullptr) {  // List
    hnode::Array* x0 = Alloc<hnode::Array>(Alloc<List<hnode_t*>>());
    for (ListIter<value_t*> it(this->items); !it.Done(); it.Next()) {
      value_t* i0 = it.Value();
      x0->children->append(i0->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC("items"), x0));
  }

  return out_node;
}


hnode_t* value__Dict::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  if (this->d) {  // Dict
    auto m = Alloc<hnode::Leaf>(StrFromC("Dict"), color_e::OtherConst);
    hnode::Array* x0 = Alloc<hnode::Array>(NewList<hnode_t*>({m}));
    for (DictIter<BigStr*, value_t*> it(this->d); !it.Done(); it.Next()) {
      auto k0 = it.Key();
      auto v0 = it.Value();
      x0->children->append(runtime::NewLeaf(k0, color_e::StringConst));
      x0->children->append(v0->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC ("d"), x0));
  }

  return out_node;
}


hnode_t* value__Eggex::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = this->expr->PrettyTree();
  L->append(Alloc<Field>(StrFromC("expr"), x0));

  if (this->as_ere) {  // Optional
    hnode_t* x1 = runtime::NewLeaf(this->as_ere, color_e::StringConst);
    L->append(Alloc<Field>(StrFromC("as_ere"), x1));
  }

  return out_node;
}


hnode_t* value__Expr::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = this->e->PrettyTree();
  L->append(Alloc<Field>(StrFromC("e"), x0));

  return out_node;
}


hnode_t* value__Template::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = this->dq->PrettyTree();
  L->append(Alloc<Field>(StrFromC("dq"), x0));

  return out_node;
}


hnode_t* value__Command::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = this->c->PrettyTree();
  L->append(Alloc<Field>(StrFromC("c"), x0));

  return out_node;
}


hnode_t* value__Block::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = this->block->PrettyTree();
  L->append(Alloc<Field>(StrFromC("block"), x0));

  return out_node;
}


hnode_t* value__Place::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = this->lval->PrettyTree();
  L->append(Alloc<Field>(StrFromC("lval"), x0));

  if (this->frame) {  // Dict
    auto m = Alloc<hnode::Leaf>(StrFromC("Dict"), color_e::OtherConst);
    hnode::Array* x1 = Alloc<hnode::Array>(NewList<hnode_t*>({m}));
    for (DictIter<BigStr*, runtime_asdl::Cell*> it(this->frame); !it.Done();
         it.Next()) {
      auto k1 = it.Key();
      auto v1 = it.Value();
      x1->children->append(runtime::NewLeaf(k1, color_e::StringConst));
      x1->children->append(v1->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC ("frame"), x1));
  }

  return out_node;
}


hnode_t* value__Module::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  if (this->defs) {  // Dict
    auto m = Alloc<hnode::Leaf>(StrFromC("Dict"), color_e::OtherConst);
    hnode::Array* x0 = Alloc<hnode::Array>(NewList<hnode_t*>({m}));
    for (DictIter<BigStr*, value_t*> it(this->defs); !it.Done(); it.Next()) {
      auto k0 = it.Key();
      auto v0 = it.Value();
      x0->children->append(runtime::NewLeaf(k0, color_e::StringConst));
      x0->children->append(v0->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC ("defs"), x0));
  }

  return out_node;
}


hnode_t* value__IO::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = Alloc<hnode::External>(this->cmd_ev);
  L->append(Alloc<Field>(StrFromC("cmd_ev"), x0));

  hnode_t* x1 = Alloc<hnode::External>(this->prompt_ev);
  L->append(Alloc<Field>(StrFromC("prompt_ev"), x1));

  return out_node;
}


hnode_t* value__BuiltinFunc::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = Alloc<hnode::External>(this->callable);
  L->append(Alloc<Field>(StrFromC("callable"), x0));

  return out_node;
}


hnode_t* value__BoundFunc::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = this->me->PrettyTree();
  L->append(Alloc<Field>(StrFromC("me"), x0));

  hnode_t* x1 = this->func->PrettyTree();
  L->append(Alloc<Field>(StrFromC("func"), x1));

  return out_node;
}


hnode_t* value__Proc::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = runtime::NewLeaf(this->name, color_e::StringConst);
  L->append(Alloc<Field>(StrFromC("name"), x0));

  hnode_t* x1 = this->name_tok->PrettyTree();
  L->append(Alloc<Field>(StrFromC("name_tok"), x1));

  hnode_t* x2 = this->sig->PrettyTree();
  L->append(Alloc<Field>(StrFromC("sig"), x2));

  hnode_t* x3 = this->body->PrettyTree();
  L->append(Alloc<Field>(StrFromC("body"), x3));

  if (this->defaults) {  // Optional
    hnode_t* x4 = this->defaults->PrettyTree();
    L->append(Alloc<Field>(StrFromC("defaults"), x4));
  }

  hnode_t* x5 = Alloc<hnode::Leaf>(this->dynamic_scope ? runtime::TRUE_STR :
                                   runtime::FALSE_STR, color_e::OtherConst);
  L->append(Alloc<Field>(StrFromC("dynamic_scope"), x5));

  return out_node;
}


hnode_t* value__Func::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = runtime::NewLeaf(this->name, color_e::StringConst);
  L->append(Alloc<Field>(StrFromC("name"), x0));

  hnode_t* x1 = this->parsed->PrettyTree();
  L->append(Alloc<Field>(StrFromC("parsed"), x1));

  if (this->pos_defaults != nullptr) {  // List
    hnode::Array* x2 = Alloc<hnode::Array>(Alloc<List<hnode_t*>>());
    for (ListIter<value_t*> it(this->pos_defaults); !it.Done(); it.Next()) {
      value_t* i2 = it.Value();
      x2->children->append(i2->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC("pos_defaults"), x2));
  }

  if (this->named_defaults) {  // Dict
    auto m = Alloc<hnode::Leaf>(StrFromC("Dict"), color_e::OtherConst);
    hnode::Array* x3 = Alloc<hnode::Array>(NewList<hnode_t*>({m}));
    for (DictIter<BigStr*, value_t*> it(this->named_defaults); !it.Done();
         it.Next()) {
      auto k3 = it.Key();
      auto v3 = it.Value();
      x3->children->append(runtime::NewLeaf(k3, color_e::StringConst));
      x3->children->append(v3->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC ("named_defaults"), x3));
  }

  if (this->module_) {  // Dict
    auto m = Alloc<hnode::Leaf>(StrFromC("Dict"), color_e::OtherConst);
    hnode::Array* x4 = Alloc<hnode::Array>(NewList<hnode_t*>({m}));
    for (DictIter<BigStr*, runtime_asdl::Cell*> it(this->module_); !it.Done();
         it.Next()) {
      auto k4 = it.Key();
      auto v4 = it.Value();
      x4->children->append(runtime::NewLeaf(k4, color_e::StringConst));
      x4->children->append(v4->PrettyTree());
    }
    L->append(Alloc<Field>(StrFromC ("module_"), x4));
  }

  return out_node;
}


hnode_t* value__Slice::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  if (this->lower) {  // Optional
    hnode_t* x0 = this->lower->PrettyTree();
    L->append(Alloc<Field>(StrFromC("lower"), x0));
  }

  if (this->upper) {  // Optional
    hnode_t* x1 = this->upper->PrettyTree();
    L->append(Alloc<Field>(StrFromC("upper"), x1));
  }

  return out_node;
}


hnode_t* value__Range::PrettyTree() {
  hnode::Record* out_node = runtime::NewRecord(value_str(this->tag()));
  List<Field*>* L = out_node->fields;

  hnode_t* x0 = Alloc<hnode::Leaf>(str(this->lower), color_e::OtherConst);
  L->append(Alloc<Field>(StrFromC("lower"), x0));

  hnode_t* x1 = Alloc<hnode::Leaf>(str(this->upper), color_e::OtherConst);
  L->append(Alloc<Field>(StrFromC("upper"), x1));

  return out_node;
}


hnode_t* value_t::PrettyTree() {
  switch (this->tag()) {
  case value_e::Undef: {
    value__Undef* obj = static_cast<value__Undef*>(this);
    return obj->PrettyTree();
  }
  case value_e::Str: {
    value__Str* obj = static_cast<value__Str*>(this);
    return obj->PrettyTree();
  }
  case value_e::BashArray: {
    value__BashArray* obj = static_cast<value__BashArray*>(this);
    return obj->PrettyTree();
  }
  case value_e::BashAssoc: {
    value__BashAssoc* obj = static_cast<value__BashAssoc*>(this);
    return obj->PrettyTree();
  }
  case value_e::Null: {
    value__Null* obj = static_cast<value__Null*>(this);
    return obj->PrettyTree();
  }
  case value_e::Bool: {
    value__Bool* obj = static_cast<value__Bool*>(this);
    return obj->PrettyTree();
  }
  case value_e::Int: {
    value__Int* obj = static_cast<value__Int*>(this);
    return obj->PrettyTree();
  }
  case value_e::Float: {
    value__Float* obj = static_cast<value__Float*>(this);
    return obj->PrettyTree();
  }
  case value_e::List: {
    value__List* obj = static_cast<value__List*>(this);
    return obj->PrettyTree();
  }
  case value_e::Dict: {
    value__Dict* obj = static_cast<value__Dict*>(this);
    return obj->PrettyTree();
  }
  case value_e::Eggex: {
    value__Eggex* obj = static_cast<value__Eggex*>(this);
    return obj->PrettyTree();
  }
  case value_e::Expr: {
    value__Expr* obj = static_cast<value__Expr*>(this);
    return obj->PrettyTree();
  }
  case value_e::Template: {
    value__Template* obj = static_cast<value__Template*>(this);
    return obj->PrettyTree();
  }
  case value_e::Command: {
    value__Command* obj = static_cast<value__Command*>(this);
    return obj->PrettyTree();
  }
  case value_e::Block: {
    value__Block* obj = static_cast<value__Block*>(this);
    return obj->PrettyTree();
  }
  case value_e::Place: {
    value__Place* obj = static_cast<value__Place*>(this);
    return obj->PrettyTree();
  }
  case value_e::Module: {
    value__Module* obj = static_cast<value__Module*>(this);
    return obj->PrettyTree();
  }
  case value_e::IO: {
    value__IO* obj = static_cast<value__IO*>(this);
    return obj->PrettyTree();
  }
  case value_e::BuiltinFunc: {
    value__BuiltinFunc* obj = static_cast<value__BuiltinFunc*>(this);
    return obj->PrettyTree();
  }
  case value_e::BoundFunc: {
    value__BoundFunc* obj = static_cast<value__BoundFunc*>(this);
    return obj->PrettyTree();
  }
  case value_e::Proc: {
    value__Proc* obj = static_cast<value__Proc*>(this);
    return obj->PrettyTree();
  }
  case value_e::Func: {
    value__Func* obj = static_cast<value__Func*>(this);
    return obj->PrettyTree();
  }
  case value_e::Slice: {
    value__Slice* obj = static_cast<value__Slice*>(this);
    return obj->PrettyTree();
  }
  case value_e::Range: {
    value__Range* obj = static_cast<value__Range*>(this);
    return obj->PrettyTree();
  }
  default:
    assert(0);
  }
}

}  // namespace value_asdl
